#define M 3
#define K 3
#define L 2

byte m[2], k[2];   /* ilu misjonarzy i kanibali obecnie na brzegu 0,1 */
byte b;            /* na ktorym brzegu lodz */
byte ml, kl;       /* ilu misjonarzy i kanibali obecnie na lodzi */

#define blokuj_jesli_przewaga_kanibali ( ((ml >= kl) || (ml == 0)) && \
					 ((m[1-b] >= k[1-b]) || (m[1-b] == 0)) && \
					 ((m[b] + ml >= k[b] + kl) || (m[b] + ml == 0)) \
                                       )
#define solution ((m[1] == M) && (k[1] == K))
#define sprawdz blokuj_jesli_przewaga_kanibali; assert(!solution)

init {
  m[0]=M;  k[0]=K;                                             /* poczatkowo wszyscy na brzegu 0 */
  do
    :: atomic{ (m[b] > 0) && (ml+kl<L) -> m[b]-- ; ml++ ; sprawdz }      /* misjonarz wsiada */
    :: atomic{ (k[b] > 0) && (ml+kl<L) -> k[b]-- ; kl++ ; sprawdz }      /* kanibal wsiada */
    :: atomic{ (ml + kl > 0) -> b = 1-b }                                /* lodz przeplywa na drugi brzeg */
    :: atomic{ (ml > 0) -> ml-- ; m[b]++ ; sprawdz }                     /* misjonarz wysiada */
    :: atomic{ (kl > 0) -> kl-- ; k[b]++ ; sprawdz }                     /* kanibal wysiada */
  od;
}
